package fr.irisa.cairn.jnimap.isl;

import java.util.AbstractMap;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.LinkedHashMap;
import java.util.List;
import java.util.Map;
import java.util.Map.Entry;

import fr.irisa.cairn.jnimap.runtime.JNIObject;


/*** PROTECTED REGION ID(ISLIDtoASTExprMap_userImport) ENABLED START ***/
	/*
		Put you custom import here ....
	*/
/*** PROTECTED REGION END ***/

/**
 *  Automatically generated by jnimap 
 * @generated
 */
public class ISLIDtoASTExprMap extends JNIObject  {
	
	/* @generated */
	protected ISLIDtoASTExprMap(long ptr) {
		/*** PROTECTED REGION ID(ISLIDtoASTExprMap_Constructor) DISABLED START ***/
		super(ptr);
		/*** PROTECTED REGION END ***/
	}
	
	/* @generated */
	protected static ISLIDtoASTExprMap build(long ptr) {
		return new ISLIDtoASTExprMap(ptr);
	}
	
	/*** PROTECTED REGION ID(ISLIDtoASTExprMap_userCode) ENABLED START ***/
	/*** PROTECTED REGION END ***/

	
	/*************************************** 
	 *	         Static Methods            * 
	 ***************************************/
	/**
	 * isl_id_to_ast_expr_alloc 
	 * 
	 * @generated
	**/
	 public static ISLIDtoASTExprMap alloc(ISLContext ctx, int min_size) { 
		/*** PROTECTED REGION ID(static_isl_id_to_ast_expr_alloc) DISABLED START ***/
		ISLIDtoASTExprMap res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLIDtoASTExprMap.build(ISLNative.isl_id_to_ast_expr_alloc(getNativePtr(ctx), min_size));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_id_to_ast_expr_to_string 
	 * 
	 * @generated
	**/
	 public static String _toString(ISLIDtoASTExprMap id2expr, int format) { 
		/*** PROTECTED REGION ID(static_isl_id_to_ast_expr_to_string) DISABLED START ***/
		String res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLNative.isl_id_to_ast_expr_to_string(getNativePtr(id2expr), format);
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	
	/*************************************** 
	 *	         Member Methods            * 
	 ***************************************/
	/**
	 * isl_id_to_ast_expr_get_ctx 
	 * 
	 * @generated
	**/
	public ISLContext getContext() {
		/*** PROTECTED REGION ID(isl_id_to_ast_expr_get_ctx) DISABLED START ***/
		ISLContext res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLContext.build(ISLNative.isl_id_to_ast_expr_get_ctx(getNativePtr(this)));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_id_to_ast_expr_copy 
	 * 
	 * @generated
	**/
	public ISLIDtoASTExprMap copy() {
		/*** PROTECTED REGION ID(isl_id_to_ast_expr_copy) DISABLED START ***/
		ISLIDtoASTExprMap res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLIDtoASTExprMap.build(ISLNative.isl_id_to_ast_expr_copy(getNativePtr(this)));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_id_to_ast_expr_free 
	 * 
	 * @take this
	 * @generated
	**/
	public void free() {
		/*** PROTECTED REGION ID(isl_id_to_ast_expr_free) DISABLED START ***/
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				ISLNative.isl_id_to_ast_expr_free(getNativePtr(this));
			} finally {
				taken(this);
			}
		}
		
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_id_to_ast_expr_has 
	 * 
	 * @generated
	**/
	public boolean containsKey(ISLIdentifier key) {
		/*** PROTECTED REGION ID(isl_id_to_ast_expr_has) DISABLED START ***/
		boolean res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLNative.isl_id_to_ast_expr_has(getNativePtr(this), getNativePtr(key)) != 0;
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_id_to_ast_expr_get 
	 * 
	 * @take key
	 * @generated
	**/
	public ISLASTExpression get(ISLIdentifier key) {
		/*** PROTECTED REGION ID(isl_id_to_ast_expr_get) DISABLED START ***/
		ISLASTExpression res;
		
		synchronized(LOCK) {
			checkParameters(key);
			try {
				res = ISLASTExpression.build(ISLNative.isl_id_to_ast_expr_get(getNativePtr(this), getNativePtr(key)));
			} finally {
				taken(key);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_id_to_ast_expr_set 
	 * 
	 * @take this key val
	 * @generated
	**/
	public ISLIDtoASTExprMap put(ISLIdentifier key, ISLASTExpression val) {
		/*** PROTECTED REGION ID(isl_id_to_ast_expr_set) DISABLED START ***/
		ISLIDtoASTExprMap res;
		
		synchronized(LOCK) {
			checkParameters(this, key, val);
			try {
				res = ISLIDtoASTExprMap.build(ISLNative.isl_id_to_ast_expr_set(getNativePtr(this), getNativePtr(key), getNativePtr(val)));
			} finally {
				taken(this);
				taken(key);
				taken(val);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_id_to_ast_expr_drop 
	 * 
	 * @take this key
	 * @generated
	**/
	public ISLIDtoASTExprMap remove(ISLIdentifier key) {
		/*** PROTECTED REGION ID(isl_id_to_ast_expr_drop) DISABLED START ***/
		ISLIDtoASTExprMap res;
		
		synchronized(LOCK) {
			checkParameters(this, key);
			try {
				res = ISLIDtoASTExprMap.build(ISLNative.isl_id_to_ast_expr_drop(getNativePtr(this), getNativePtr(key)));
			} finally {
				taken(this);
				taken(key);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	
	public String toString() {
		/*** PROTECTED REGION ID(ISLIDtoASTExprMap_toString) DISABLED START ***/
			return ISLPrettyPrinter.asString(this);
		/*** PROTECTED REGION END ***/
	}
}
